## nxt-firmware 1.29

=== AT91SAM7S256/SAM7S256/gcc/Makefile ===
BASE = ../..
SRCDIR = $(BASE)/Source
DBGDIR = $(BASE)/armdebug/Debugger
CPUINCDIR = $(BASE)/SAM7S256/Include

GIT_VERSION := $(shell git rev-parse --short=7 HEAD)
CUSTOM_FIRMWAREVERSION = $(GIT_VERSION)

TARGET = nxt_firmware

# Set to 'y' to enable embedded debuger.
ARMDEBUG = n

ARM_SOURCES =
THUMB_SOURCES = c_button.c c_cmd.c c_comm.c c_display.c c_input.c c_ioctrl.c \
		c_loader.c c_lowspeed.c c_output.c c_sound.c c_ui.c \
		d_bt.c d_button.c d_display.c d_hispeed.c d_input.c \
		d_ioctrl.c d_loader.c d_lowspeed.c d_output.c d_sound.c \
		d_timer.c d_usb.c \
		m_sched.c \
		abort.c errno.c sbrk.c strtod.c sscanf.c \
		Cstartup_SAM7.c

ASM_ARM_SOURCE = Cstartup.S
ASM_THUMB_SOURCE =

vpath %.c $(SRCDIR)
vpath %.c $(CPUINCDIR)
vpath %.c lib
vpath %.S $(CPUINCDIR)

INCLUDES =

MCU = arm7tdmi
STARTOFUSERFLASH_DEFINES = -DSTARTOFUSERFLASH_FROM_LINKER=1
VERSION_DEFINES = -DCUSTOM_FIRMWAREVERSION=\"$(CUSTOM_FIRMWAREVERSION)\"
DEFINES = -DPROTOTYPE_PCB_4 -DNEW_MENU -DROM_RUN -DVECTORS_IN_RAM \
	  $(STARTOFUSERFLASH_DEFINES) $(VERSION_DEFINES)
OPTIMIZE = -Os -fno-strict-aliasing \
	   -ffunction-sections -fdata-sections
WARNINGS = -Wall -W -Wundef -Wno-unused -Wno-format
THUMB_INTERWORK = -mthumb-interwork
CFLAGS = -g -mcpu=$(MCU) $(THUMB) $(THUMB_INTERWORK) $(WARNINGS) $(OPTIMIZE)
ASFLAGS = -g -mcpu=$(MCU) $(THUMB) $(THUMB_INTERWORK)
CPPFLAGS = $(INCLUDES) $(DEFINES) -MMD
LDSCRIPT = nxt.ld
LDFLAGS = -nostdlib -T $(LDSCRIPT) -Wl,--gc-sections
LDLIBS = -lc -lm -lgcc

ifeq ($(ARMDEBUG),y)
ASM_ARM_SOURCE += abort_handler.S undef_handler.S debug_hexutils.S \
                  debug_stub.S debug_comm.S debug_opcodes.S \
                  debug_runlooptasks.S
vpath %.S $(DBGDIR)
DEFINES += -DARMDEBUG
INCLUDES += -I../../armdebug/Debugger
endif

CROSS_COMPILE = arm-none-eabi-
CC = $(CROSS_COMPILE)gcc
OBJDUMP = $(CROSS_COMPILE)objdump
OBJCOPY = $(CROSS_COMPILE)objcopy

FWFLASH = fwflash

ARM_OBJECTS = $(ARM_SOURCES:%.c=%.o) $(ASM_ARM_SOURCE:%.S=%.o)
THUMB_OBJECTS = $(THUMB_SOURCES:%.c=%.o) $(THUMB_ARM_SOURCE:%.S=%.o)
OBJECTS = $(ARM_OBJECTS) $(THUMB_OBJECTS)

all: bin

elf: $(TARGET).elf
bin: $(TARGET).bin
sym: $(TARGET).sym
lst: $(TARGET).lst

$(TARGET).elf: THUMB = -mthumb
$(TARGET).elf: $(OBJECTS) $(LDSCRIPT)
	$(LINK.c) $(OBJECTS) $(LOADLIBES) $(LDLIBS) -o $@

%.bin: %.elf
	$(OBJCOPY) --pad-to=0x140000 --gap-fill=0xff -O binary $< $@

%.sym: %.elf
	$(OBJDUMP) -h -t $< > $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

$(THUMB_OBJECTS): THUMB = -mthumb

-include $(OBJECTS:%.o=%.d)

LAST_CUSTOM_FIRMWAREVERSION=none
-include version.mak
ifneq ($(LAST_CUSTOM_FIRMWAREVERSION),$(CUSTOM_FIRMWAREVERSION))
.PHONY: version.mak
version.mak:
	echo "LAST_CUSTOM_FIRMWAREVERSION = $(CUSTOM_FIRMWAREVERSION)" > $@
endif

c_ui.o: version.mak

program: $(TARGET).bin
	$(FWFLASH) $(TARGET).bin

clean:
	rm -f $(TARGET).elf $(TARGET).bin $(TARGET).sym $(TARGET).lst \
	$(OBJECTS) $(OBJECTS:%.o=%.d) version.mak

## nxt-firmware 1.29-20120908+dfsg

=== debian/changelog ===
nxt-firmware (1.29-20120908+dfsg-7) unstable; urgency=medium

  * Remove references to RCX as it is not supported.

 -- Dominik George <nik@naturalnet.de>  Thu, 19 Jan 2017 16:11:05 +0100

nxt-firmware (1.29-20120908+dfsg-6) unstable; urgency=medium

  * Inject timestamp from changelog into build to make it reproducible.
    Thanks to Eduard Sanou for pointing out. (Closes: #849926)
  * debian/watch: added a fake site to explain about the current
    status of the original upstream homepage.

 -- Dominik George <nik@naturalnet.de>  Fri, 06 Jan 2017 16:44:52 +0100

nxt-firmware (1.29-20120908+dfsg-3) unstable; urgency=low

  * Move AppStream metadata to new location /usr/share/metainfo/.
  * Add myself as uploader.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 23 Dec 2016 08:05:10 +0000

nxt-firmware (1.29-20120908+dfsg-2) unstable; urgency=medium

  * Adjusded d/copyright reflecting issues discovered using debmake -k.

 -- Dominik George <nik@naturalnet.de>  Thu, 20 Oct 2016 12:00:34 +0000

nxt-firmware (1.29-20120908+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #736124)

 -- Dominik George <nik@naturalnet.de>  Wed, 19 Oct 2016 12:27:42 +0200

=== debian/control ===
Source: nxt-firmware
Section: electronics
Priority: optional
Maintainer: Debian LEGO Team <debian-lego-team@lists.alioth.debian.org>
Uploaders:
 Dominik George <nik@naturalnet.de>,
 Petter Reinholdtsen <pere@debian.org>,
Build-Depends:
 debhelper (>= 9),
 gcc-arm-none-eabi,
 libnewlib-arm-none-eabi,
Standards-Version: 3.9.8
Homepage: http://nxt-firmware.ni.fr.eu.org/
Vcs-Git: https://anonscm.debian.org/git/debian-lego/nxt-firmware.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nxt-firmware.git

Package: nxt-firmware
Architecture: all
Depends:
 ${misc:Depends},
Recommends:
 libnxt,
Suggests:
 nbc,
Description: Improved firmware for LEGO Mindstorms NXT bricks
 The NXT Improved Firmware is a community-based open source project
 around the original LEGO Mindstorms firmware for the NXT
 bricks.
 .
 The firmware can be installed on the robot control bricks of type NXT.
 It is almost identical to the original firmware, meaning that
 all existing software working with the original firmware can be expected
 to work with the improved firmware as well.
 .
 The main differences between the original firmware and the improved
 firmware are the addition of absolute position regulation for motors and
 that it can be built with GCC rather than the non-free toolchain used by
 the LEGO Group.
 .
 This package contains the firmware image file, which can be flashed onto
 the brick with various tools, e.g. fwflash from the libnxt package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_build:
	make -C AT91SAM7S256/SAM7S256/gcc

override_dh_auto_clean:
	make -C AT91SAM7S256/SAM7S256/gcc clean

=== debian/watch ===
version=4
opts=dversionmangle=s/.*\+dfsg/0.No-Release/ \
https://people.debian.org/~eriberto/ FakeWatchNoUpstreamReleaseForThisPackage-(\d\S+)\.gz

## nxt-firmware 1.29.2

=== AT91SAM7S256/SAM7S256/gcc/Makefile ===
--- 
+++ 
@@ -3,8 +3,13 @@
 DBGDIR = $(BASE)/armdebug/Debugger
 CPUINCDIR = $(BASE)/SAM7S256/Include
 
-GIT_VERSION := $(shell git rev-parse --short=7 HEAD)
-CUSTOM_FIRMWAREVERSION = $(GIT_VERSION)
+DATE_FMT = +%Y-%m-%dT%H:%M
+ifndef SOURCE_DATE_EPOCH
+    SOURCE_DATE_EPOCH = $(shell git log -1 --pretty=%ct)
+endif
+BUILD_DATE ?= $(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null \
+	      || LC_ALL=C date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null \
+	      || LC_ALL=C date -u "$(DATE_FMT)")
 
 TARGET = nxt_firmware
 
@@ -33,7 +38,7 @@
 
 MCU = arm7tdmi
 STARTOFUSERFLASH_DEFINES = -DSTARTOFUSERFLASH_FROM_LINKER=1
-VERSION_DEFINES = -DCUSTOM_FIRMWAREVERSION=\"$(CUSTOM_FIRMWAREVERSION)\"
+VERSION_DEFINES = -D'BUILD_DATE="$(BUILD_DATE)"'
 DEFINES = -DPROTOTYPE_PCB_4 -DNEW_MENU -DROM_RUN -DVECTORS_IN_RAM \
 	  $(STARTOFUSERFLASH_DEFINES) $(VERSION_DEFINES)
 OPTIMIZE = -Os -fno-strict-aliasing \
@@ -45,7 +50,7 @@
 CPPFLAGS = $(INCLUDES) $(DEFINES) -MMD
 LDSCRIPT = nxt.ld
 LDFLAGS = -nostdlib -T $(LDSCRIPT) -Wl,--gc-sections
-LDLIBS = -lc -lm -lgcc
+LDLIBS = -lc -lm -lgcc -lnosys
 
 ifeq ($(ARMDEBUG),y)
 ASM_ARM_SOURCE += abort_handler.S undef_handler.S debug_hexutils.S \
@@ -91,12 +96,12 @@
 
 -include $(OBJECTS:%.o=%.d)
 
-LAST_CUSTOM_FIRMWAREVERSION=none
+LAST_BUILD_DATE=none
 -include version.mak
-ifneq ($(LAST_CUSTOM_FIRMWAREVERSION),$(CUSTOM_FIRMWAREVERSION))
+ifneq ($(LAST_BUILD_DATE),$(BUILD_DATE))
 .PHONY: version.mak
 version.mak:
-	echo "LAST_CUSTOM_FIRMWAREVERSION = $(CUSTOM_FIRMWAREVERSION)" > $@
+	echo "LAST_BUILD_DATE = $(BUILD_DATE)" > $@
 endif
 
 c_ui.o: version.mak

=== debian/changelog ===
nxt-firmware (1.29.2-1) unstable; urgency=medium

  * New upstream version 1.29.2
    - Dropped 0000-missing-read.patch and 1000-fixed-date-time.patch
      included upstream.
    - Dropped Debian specific nxt-update-firmware now provided by upstream.
  * Adjusted d/watch to check upstream gpg file signature too.
  * Added d/gbp.conf enforcing the use of pristine-tar.
  * Switched debhelper dependency to debhelper-compat.
  * Switched appstream metadata license back to MIT and adjusted d/copyright.
  * Changed Vcs-Git entry to canonical form.
  * Corrected typo in d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 13 Feb 2023 22:22:01 +0100

nxt-firmware (1.29-20120908+dfsg-9) unstable; urgency=medium

  * Renamed fix-date-time.patch into new naming scheme.
  * Added override for lintians section suggestion.
  * Added simple upstream/metadata.
  * Flagged package as multi-arch foreign, as it contain no binaries.
  * Renamed appstream metadata id to use _ instead of - for
    compatibility with D-Bus.
  * Changed upstream contact on request from upstream.
  * Switched appstream metadata ID to reverse domain-name.
  * Changed appstream metadata license to match license in d/copyright.
  * Updated d/watch with new upstream location.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 30 Sep 2021 07:41:37 +0200

nxt-firmware (1.29-20120908+dfsg-8) unstable; urgency=medium

  [ Dominik George ]
  * Salsa migration.
    + Update VCS-URLs.

  [ Petter Reinholdtsen ]
  * Added 0000-missing-read.patch to fix build problem (undefined _read)
    (Closes: #954598).
  * Updated Standards-Version from 3.9.8 to 4.6.0.
  * Removed trailing space from d/rules.
  * Updated debhelper compat level from 9 to 13.
  * Removed obsolete lintian override no-upstream-changelog.
  * Updated lintian override name debian-watch-may-check-gpg-signature to
    debian-watch-does-not-check-gpg-signature.
  * Documented in d/control the build do not need root access.
  * Switched copyright format url to https.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 24 Sep 2021 16:56:14 +0200

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,18 @@
  Dominik George <nik@naturalnet.de>,
  Petter Reinholdtsen <pere@debian.org>,
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 13),
  gcc-arm-none-eabi,
  libnewlib-arm-none-eabi,
-Standards-Version: 3.9.8
+Standards-Version: 4.6.0
 Homepage: http://nxt-firmware.ni.fr.eu.org/
-Vcs-Git: https://anonscm.debian.org/git/debian-lego/nxt-firmware.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nxt-firmware.git
+Vcs-Git: https://salsa.debian.org/debian-lego-team/nxt-firmware.git
+Vcs-Browser: https://salsa.debian.org/debian-lego-team/nxt-firmware
+Rules-Requires-Root: no
 
 Package: nxt-firmware
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Recommends:

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_auto_build:
 	make -C AT91SAM7S256/SAM7S256/gcc

## nxt-firmware 1.29.7

=== Makefile ===
BASE = .
SRCDIR = $(BASE)/src
LIBDIR = $(BASE)/lib
DBGDIR = $(BASE)/armdebug/Debugger
CPUINCDIR = $(BASE)/include
STARTUPDIR = $(BASE)/startup
TOOLSDIR = $(BASE)/tools

DATE_FMT = +%Y-%m-%dT%H:%M
ifndef SOURCE_DATE_EPOCH
    SOURCE_DATE_EPOCH = $(shell git log -1 --pretty=%ct)
endif
BUILD_DATE ?= $(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null \
	      || LC_ALL=C date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null \
	      || LC_ALL=C date -u "$(DATE_FMT)")

TARGET = nxt_firmware

# Set to 'y' to enable embedded debuger.
ARMDEBUG = n

ARM_SOURCES =
THUMB_SOURCES = c_button.c c_cmd.c c_comm.c c_display.c c_input.c c_ioctrl.c \
		c_loader.c c_lowspeed.c c_output.c c_sound.c c_ui.c \
		d_bt.c d_button.c d_display.c d_hispeed.c d_input.c \
		d_ioctrl.c d_loader.c d_lowspeed.c d_output.c d_sound.c \
		d_timer.c d_usb.c \
		m_sched.c \
		sscanf.c \
		Cstartup_SAM7.c

ASM_ARM_SOURCE = Cstartup.S
ASM_THUMB_SOURCE =

BITMAPS = Cursor Display Fail Info LowBattery Ok Wait \
	  RCXintro_1 RCXintro_2 RCXintro_3 RCXintro_4 RCXintro_5 RCXintro_6 \
	  RCXintro_7 RCXintro_8 RCXintro_9 RCXintro_10 RCXintro_11 \
	  RCXintro_12 RCXintro_13 RCXintro_14 RCXintro_15 RCXintro_16 \
	  Test1 Test2

ICONS = Connections Devices Font Icons Port Running Status Step

MENUS = Mainmenu \
	Submenu01 Submenu02 Submenu03 Submenu04 Submenu05 Submenu06 Submenu07

vpath %.c $(SRCDIR)
vpath %.c $(LIBDIR)
vpath %.c $(STARTUPDIR)
vpath %.S $(STARTUPDIR)

INCLUDES = -I$(BASE) -I$(CPUINCDIR)

MCU = arm7tdmi
STARTOFUSERFLASH_DEFINES = -DSTARTOFUSERFLASH_FROM_LINKER=1
VERSION_DEFINES = -D'BUILD_DATE="$(BUILD_DATE)"'
DEFINES = -DPROTOTYPE_PCB_4 -DNEW_MENU -DROM_RUN -DVECTORS_IN_RAM \
	  $(STARTOFUSERFLASH_DEFINES) $(VERSION_DEFINES)
OPTIMIZE = -Os -fno-strict-aliasing \
	   -ffunction-sections -fdata-sections
WARNINGS = -Wall -W -Wundef -Wno-unused -Wno-format
THUMB_INTERWORK = -mthumb-interwork
SPECS = --specs=picolibc.specs
CFLAGS = -g -mcpu=$(MCU) $(THUMB) $(THUMB_INTERWORK) \
	 $(WARNINGS) $(OPTIMIZE) $(SPECS)
ASFLAGS = -g -mcpu=$(MCU) $(THUMB) $(THUMB_INTERWORK) \
	  $(SPECS)
CPPFLAGS = $(INCLUDES) $(DEFINES) -MMD
LDSCRIPT = $(LIBDIR)/nxt.ld
LDFLAGS = -nostdlib -T $(LDSCRIPT) -Wl,--gc-sections
LDLIBS = -lc -lm -lgcc

ifeq ($(ARMDEBUG),y)
ASM_ARM_SOURCE += abort_handler.S undef_handler.S debug_hexutils.S \
                  debug_stub.S debug_comm.S debug_opcodes.S \
                  debug_runlooptasks.S
vpath %.S $(DBGDIR)
DEFINES += -DARMDEBUG
INCLUDES += -I$(DBGDIR)
endif

CROSS_COMPILE = arm-none-eabi-
CC = $(CROSS_COMPILE)gcc
OBJDUMP = $(CROSS_COMPILE)objdump
OBJCOPY = $(CROSS_COMPILE)objcopy

FWFLASH = fwflash

ARM_OBJECTS = $(ARM_SOURCES:%.c=%.o) $(ASM_ARM_SOURCE:%.S=%.o)
THUMB_OBJECTS = $(THUMB_SOURCES:%.c=%.o) $(THUMB_ARM_SOURCE:%.S=%.o)
OBJECTS = $(ARM_OBJECTS) $(THUMB_OBJECTS)

BITMAPS_SOURCES = $(BITMAPS:%=%.h)
ICONS_SOURCES = $(ICONS:%=%.h)
MENUS_SOURCES = $(MENUS:%=%.h)

all: bin

elf: $(TARGET).elf
bin: $(TARGET).bin
sym: $(TARGET).sym
lst: $(TARGET).lst

$(TARGET).elf: THUMB = -mthumb
$(TARGET).elf: $(OBJECTS) $(LDSCRIPT)
	$(LINK.c) $(OBJECTS) $(LOADLIBES) $(LDLIBS) -o $@

%.bin: %.elf
	$(OBJCOPY) --pad-to=0x140000 --gap-fill=0xff -O binary $< $@

%.sym: %.elf
	$(OBJDUMP) -h -t $< > $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

$(THUMB_OBJECTS): THUMB = -mthumb

-include $(OBJECTS:%.o=%.d)

LAST_BUILD_DATE=none
-include version.mak
ifneq ($(LAST_BUILD_DATE),$(BUILD_DATE))
.PHONY: version.mak
version.mak:
	echo "LAST_BUILD_DATE = $(BUILD_DATE)" > $@
endif

c_ui.o: version.mak
c_ui.o: $(BITMAPS_SOURCES) $(ICONS_SOURCES) $(MENUS_SOURCES)

%.h: data/bitmaps/%.toml data/bitmaps/%.png
	python3 $(TOOLSDIR)/img2src -o $@ $^

%.h: data/icons/%.toml data/icons/%.png
	python3 $(TOOLSDIR)/img2src -o $@ $^

%.h: data/menus/%.toml
	python3 $(TOOLSDIR)/menu2src -o $@ $<

program: $(TARGET).bin
	$(FWFLASH) $(TARGET).bin

clean:
	rm -f $(TARGET).elf $(TARGET).bin $(TARGET).sym $(TARGET).lst \
	$(OBJECTS) $(OBJECTS:%.o=%.d) version.mak \
	$(BITMAPS_SOURCES) $(ICONS_SOURCES) $(MENUS_SOURCES)

=== armdebug/SConstruct ===
# -*- mode: python -*-
###############################################################
# This scons build script is used to check the armdebug project
# code for syntax errors. It does not build working executable
# code since it links to external routines.
###############################################################

import os
import os.path
import new
from glob import glob

###############################################################
# Utility functions.
###############################################################

# Similar to env.WhereIs, but always searches os.environ.
def find_on_path(filename):
    paths = os.environ.get('PATH')
    if not paths:
        return None
    for p in paths.split(':'):
        path = os.path.abspath(os.path.join(p, filename))
        if os.path.isfile(path):
            return p
    return None

# Run the given gcc binary, and parses its output to work out the gcc
# version.
def determine_gcc_version(gcc_binary):
    stdout = os.popen('%s --version' % gcc_binary)
    gcc_output = stdout.read().split()
    stdout.close()
    grab_next = False
    for token in gcc_output:
        if grab_next:
            return token
        elif token[-1] == ')':
            grab_next = True
    return None

# Check that a given cross-compiler tool exists. If it does, the path is
# added to the build environment, and the given environment variable is
# set to the tool name.
#
# This is used to check for the presence of a working cross-compiler
# toolchain, and to properly set up the environment to do it. See below
# in the configuration section for details.
def CheckTool(context, envname, toolname=None, hostprefix=None):
    toolname = toolname or envname.lower()
    if hostprefix is None:
        hostprefix = '%s-' % context.env['CROSS_COMPILE_HOST']
    toolname = '%s%s' % (hostprefix, toolname)
    context.Message("Checking for %s..." % toolname)
    toolpath = find_on_path(toolname)
    if not toolpath:
        context.Result('not found')
        return False
    else:
        context.Result('ok')
        context.env[envname] = toolname
        context.env.AppendENVPath('PATH', toolpath)
        return True

# Find the correct variant and version of libgcc.a in the cross-compiler
# toolchain.
def CheckLibGcc(context, gccname):
    context.Message("Locating a cross-compiled libgcc...")
    toolpath = find_on_path(gccname)
    if not toolpath:
        context.Result("%s not found" % toolname)
        return False
    gcc_version = determine_gcc_version(gccname)
    if not gcc_version:
        context.Result("Could not determine gcc version")
        return False
    gcc_install_dir = os.path.split(os.path.normpath(toolpath))[0]
    for libdir in ['interwork', 'thumb', '']:
        libgcc_path = os.path.join(gcc_install_dir, 'lib', 'gcc',
                               context.env['CROSS_COMPILE_HOST'],
                               gcc_version, libdir, 'libgcc.a')
        if os.path.isfile(libgcc_path):
            break
    if not os.path.isfile(libgcc_path):
        context.Result("libgcc.a not found")
        return False
    context.Result("ok - " + libgcc_path)
    context.env.Append(LIBGCC=libgcc_path)
    return True

def CheckDoxygen(context):
    context.Message("Looking for Doxygen...")
    doxypath = find_on_path('doxygen')
    if doxypath:
        context.Result("ok")
        context.env.AppendENVPath('PATH', doxypath)
        context.env['WITH_DOXYGEN'] = True
    else:
        context.Result("not found")
        context.env['WITH_DOXYGEN'] = False



###############################################################
# Options that can be provided on the commandline
###############################################################

opts = Variables('scons.options', ARGUMENTS)

opts.Add(PathVariable('gccprefix',
                    'Prefix of the cross-gcc to use (by default arm-none-eabi)',
                    'arm-none-eabi', PathVariable.PathAccept))

Help('''
Type: 'scons' to build object files.

 - To use another cross-gcc than arm-none-eabi-gcc:
     scons gccprefix=arm-softfloat-eabi

Options are saved persistent in the file 'scons.options'. That means
after you have called e.g. 'scons gccprefix=arm-softfloat-eabi' it's enough
to call only 'scons' to build both using the new gcc version again.
''')

###############################################################
# Construct and configure a cross-compiler environment
###############################################################
env = Environment(options = opts,
                  tools = ['gcc', 'as', 'gnulink', 'ar'],
                  toolpath = ['scons_tools'],
                  LIBGCC = [], CPPPATH = '#',
                  WITH_DOXYGEN = False)
opts.Update(env)
opts.Save('scons.options', env)

if not env.GetOption('clean'):
    conf = Configure(env, custom_tests = {'CheckTool': CheckTool,
                                          'CheckLibGcc': CheckLibGcc,
                                          'CheckDoxygen': CheckDoxygen})
    conf.env['CROSS_COMPILE_HOST'] = env['gccprefix']
    if not (conf.CheckTool('CC', 'gcc') and conf.CheckTool('AR') and
            conf.CheckTool('OBJCOPY') and conf.CheckTool('LINK', 'ld') and
            conf.CheckLibGcc(conf.env['CC'])):
        print "Missing or incomplete arm-elf toolchain, cannot continue!"
        Exit(1)
    env = conf.Finish()

mycflags = ['-mcpu=arm7tdmi', '-Os', '-Wextra', '-Wall', '-Werror',
                      '-Wno-div-by-zero', '-Wfloat-equal', '-Wshadow',
                      '-Wpointer-arith', '-Wbad-function-cast',
                      '-Wmissing-prototypes', '-ffreestanding',
                      '-fsigned-char', '-ffunction-sections', '-std=gnu99',
                      '-fdata-sections', '-fomit-frame-pointer', '-msoft-float']
myasflags = ['-Wall', '-Werror', '-Os'];
if str(env['LIBGCC']).find('interwork') != -1:
    mycflags.append('-mthumb-interwork')
    myasflags.append('-Wa,-mcpu=arm7tdmi,-mfpu=softfpa,-mthumb-interwork')
elif str(env['LIBGCC']).find('thumb') != -1:
    mycflags.append('-mthumb')
    myasflags.append('-Wa,-mcpu=arm7tdmi,-mfpu=softfpa,-mthumb')
else:
    myasflags.append('-Wa,-mcpu=arm7tdmi,-mfpu=softfpa')
mycflags.append('-g')
mycflags.append('-ggdb')
# Big Endian Output (disabled by default)
#mycflags.append('-D__BIG_ENDIAN__')
# Test build for NxOS (Comment out for NXT Firmware)
mycflags.append('-D__NXOS__')

myasflags.append('-g')
myasflags.append('-ggdb')
# Big Endian Output (disabled by default)
#mycflags.append('-D__BIG_ENDIAN__')
# Test build for NxOS (Comment out for NXT Firmware)
myasflags.append('-D__NXOS__')

env.Replace(CCFLAGS = mycflags, ASFLAGS = myasflags )

# Build the baseplate, and all selected application kernels.

numProcs = os.sysconf('SC_NPROCESSORS_ONLN')
SConscript(['SConscript'], 'numProcs env CheckTool')

=== tests/Makefile ===
NBC = nbc
OPTIMIZE = -Z2
FIRMWARE =
PYTHON = python3
# or PYTHON = poetry -C path/to/nxt-python run python

TESTS = float

tests: $(TESTS:%=%.diff)

build: $(TESTS:%=%.rxe)

%.rxe: %.nxc
	$(NBC) $(OPTIMIZE) $(FIRMWARE) -O=$@ $<

%.load: %.rxe
	$(NBC) $(OPTIMIZE) $(FIRMWARE) -d -b $<

%.out: %.load
	$(PYTHON) term.py -qos $* > $@

%.diff: %.out %.expect
	diff $^ > $@

%.S: %.nxc
	$(NBC) $(OPTIMIZE) $(FIRMWARE) -nbc=$@ $<

clean-out:
	rm -f $(TESTS:%=%.out) $(TESTS:%=%.diff)

clean: clean-out
	rm -f $(TESTS:%=%.rxe)

.SECONDARY:

.DELETE_ON_ERROR:

=== debian/changelog ===
nxt-firmware (1.29.7-6) unstable; urgency=medium

  * Make autopkgtest work for both libnxt version 0.4 and 0.5.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Sun, 23 Feb 2025 10:59:01 +0100

nxt-firmware (1.29.7-5) unstable; urgency=medium

  * Update autopgktest for new libnxt version.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Fri, 14 Feb 2025 12:24:23 +0100

nxt-firmware (1.29.7-4) unstable; urgency=medium

  * Go back to using picolibc, remove patch.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Thu, 06 Feb 2025 17:43:45 +0100

nxt-firmware (1.29.7-3) unstable; urgency=medium

  * Temporarily revert to use newlib instead of picolibc.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 15 Jan 2025 19:22:22 +0100

nxt-firmware (1.29.7-2) unstable; urgency=medium

  * Tell blhc to ignore hardening rules for firmware.
  * Add autopkgtest.
  * Fix d/copyright, use https.
  * metainfo: restrict device ID to NXT brick while in bootloader mode.
  * Rename metainfo file to match its id.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 16 Oct 2024 14:56:27 +0200

nxt-firmware (1.29.7-1) unstable; urgency=medium

  [ Nicolas Schodet ]
  * New upstream version 1.29.7 (Closes: #1065665).
    - Update to follow new upstream directory structure.
    - Update build deps and copyright for new version.
  * Update standards version to 4.7.0, no changes needed.
  * Remove source lintian overrides now that releases are signed.
  * Update upstream signing key.
  * Fix and add lintian overrides.
  * Update debian/copyright for debian files.
  * Add myself as uploader.
  * Add homepage and developer to appstream metadata.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 04 Sep 2024 21:55:50 +0200

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,14 @@
 Uploaders:
  Dominik George <nik@naturalnet.de>,
  Petter Reinholdtsen <pere@debian.org>,
+ Nicolas Schodet <nico@ni.fr.eu.org>,
 Build-Depends:
  debhelper-compat (= 13),
  gcc-arm-none-eabi,
- libnewlib-arm-none-eabi,
-Standards-Version: 4.6.0
-Homepage: http://nxt-firmware.ni.fr.eu.org/
+ picolibc-arm-none-eabi,
+ python3-pil,
+Standards-Version: 4.7.0
+Homepage: https://nxt-firmware.ni.fr.eu.org/
 Vcs-Git: https://salsa.debian.org/debian-lego-team/nxt-firmware.git
 Vcs-Browser: https://salsa.debian.org/debian-lego-team/nxt-firmware
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_auto_build:
	# No hardening for NXT firmware, tell blhc to ignore firmware build.
	@echo 'blhc: ignore-line-regexp: ^arm-none-eabi-.*'
	dh_auto_build

=== debian/tests/control ===
Tests: nxt-not-found
Depends: @, libnxt

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://nxt-firmware.ni.fr.eu.org/releases/ .*/nxt-firmware-(\d\S+).tar.gz
